Index: /code/trunk/data/particle/ExplosionComp1.particle
===================================================================
--- /code/trunk/data/particle/ExplosionComp1.particle	(revision 5928)
+++ /code/trunk/data/particle/ExplosionComp1.particle	(revision 5929)
@@ -41,5 +41,5 @@
 		repeat_delay_max	2.5
 		width		20
-		hight		20
+		height		20
 		depth		0
 	}
Index: /code/trunk/data/particle/sparks2.particle
===================================================================
--- /code/trunk/data/particle/sparks2.particle	(revision 5929)
+++ /code/trunk/data/particle/sparks2.particle	(revision 5929)
@@ -0,0 +1,51 @@
+
+particle_system Orxonox/sparks2
+{
+	quota	1000
+	material	PE/Flare
+	particle_width	15
+	particle_height	40
+	cull_each	true
+	renderer	billboard
+	sorted	false
+	local_space	false
+	iteration_interval	0
+	nonvisible_update_timeout	0
+	billboard_type	oriented_self
+	billboard_origin	center
+	billboard_rotation_type	texcoord
+	common_up_vector	0 1 0
+	point_rendering	false
+	accurate_facing	false
+
+	emitter Point
+	{
+		angle	180
+		colour	0.1 0.1 0.1 1
+		colour_range_start	0.1 0.1 0.1 1
+		colour_range_end	1 1 1 1
+		direction	0 0 -1
+		emission_rate	5000
+		position	0 0 0
+		velocity	10
+		velocity_min	15
+		velocity_max	150
+		time_to_live	0.5
+		time_to_live_min	0.5
+		time_to_live_max	0.5
+		duration	0
+		duration_min	0
+		duration_max	0
+		repeat_delay	0
+		repeat_delay_min	0
+		repeat_delay_max	0
+	}
+
+	affector ColourFader
+	{
+		red	-2.0
+		green	-2.0
+		blue	-2.0
+		alpha	0
+	}
+}
Index: /code/trunk/src/OrxonoxConfig.cmake
===================================================================
--- /code/trunk/src/OrxonoxConfig.cmake	(revision 5928)
+++ /code/trunk/src/OrxonoxConfig.cmake	(revision 5929)
@@ -38,4 +38,7 @@
   OPTION(PCH_ENABLE "Global PCH switch" TRUE)
 ENDIF()
+
+# Global switch to disable multiple file compilations
+OPTION(DISABLE_COMPILATIONS "Global multi-file compilation switch" FALSE)
 
 # Use WinMain() or main()?
Index: /code/trunk/src/external/bullet/BulletCollision/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/bullet/BulletCollision/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/bullet/BulletCollision/CMakeLists.txt	(revision 5929)
@@ -1,3 +1,6 @@
 ADD_SOURCE_FILES(BULLET_FILES
+
+COMPILATION_BEGIN BulletCollisionCompilation.cpp
+
 	BroadphaseCollision/btAxisSweep3.cpp
 	BroadphaseCollision/btBroadphaseProxy.cpp
@@ -68,13 +71,9 @@
 	Gimpact/btContactProcessing.cpp
 	Gimpact/btGImpactShape.cpp
-	Gimpact/gim_contact.cpp
 	Gimpact/btGImpactBvh.cpp
 	Gimpact/btGenericPoolAllocator.cpp
-	Gimpact/gim_memory.cpp
 	Gimpact/btGImpactCollisionAlgorithm.cpp
 	Gimpact/btTriangleShapeEx.cpp
-	Gimpact/gim_tri_collision.cpp
 	Gimpact/btGImpactQuantizedBvh.cpp
-	Gimpact/gim_box_set.cpp
 
 	NarrowPhaseCollision/btContinuousConvexCollision.cpp
@@ -89,4 +88,13 @@
 	NarrowPhaseCollision/btSubSimplexConvexCast.cpp
 	NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
+
+COMPILATION_END
+
+COMPILATION_BEGIN BulletGImpactCompilation.cpp
+	Gimpact/gim_contact.cpp
+	Gimpact/gim_memory.cpp
+	Gimpact/gim_tri_collision.cpp
+	Gimpact/gim_box_set.cpp
+COMPILATION_END
 
 	# Headers
Index: /code/trunk/src/external/bullet/BulletDynamics/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/bullet/BulletDynamics/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/bullet/BulletDynamics/CMakeLists.txt	(revision 5929)
@@ -1,3 +1,6 @@
 ADD_SOURCE_FILES(BULLET_FILES
+
+COMPILATION_BEGIN BulletDynamicsCompilation.cpp
+
 	ConstraintSolver/btContactConstraint.cpp
 	ConstraintSolver/btConeTwistConstraint.cpp
@@ -19,4 +22,6 @@
 
 	Character/btKinematicCharacterController.cpp
+
+COMPILATION_END
 
 	# Headers
Index: /code/trunk/src/external/bullet/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/bullet/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/bullet/CMakeLists.txt	(revision 5929)
@@ -27,13 +27,7 @@
 ADD_SUBDIRECTORY(LinearMath)
 
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
-
 ORXONOX_ADD_LIBRARY(bullet_orxonox
   ORXONOX_EXTERNAL
   NO_DLL_INTERFACE
-  PCH_FILE
-    BulletPrecompiledHeaders.h
   VERSION
     2.74
Index: /code/trunk/src/external/bullet/LinearMath/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/bullet/LinearMath/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/bullet/LinearMath/CMakeLists.txt	(revision 5929)
@@ -1,7 +1,10 @@
 ADD_SOURCE_FILES(BULLET_FILES
+
+COMPILATION_BEGIN BulletLinearMathCompilation.cpp
 		btConvexHull.cpp
 		btQuickprof.cpp
 		btGeometryUtil.cpp
 		btAlignedAllocator.cpp
+COMPILATION_END
 
 		# Headers
Index: /code/trunk/src/external/ceguilua/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/ceguilua/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/ceguilua/CMakeLists.txt	(revision 5929)
@@ -67,8 +67,4 @@
 )
 
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
-
 SOURCE_GROUP("Source" FILES ${CEGUILUA_FILES})
 
Index: /code/trunk/src/external/cpptcl/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/cpptcl/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/cpptcl/CMakeLists.txt	(revision 5929)
@@ -32,8 +32,4 @@
 )
 
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
-
 ORXONOX_ADD_LIBRARY(cpptcl_orxonox
   ORXONOX_EXTERNAL
Index: /code/trunk/src/external/ogreceguirenderer/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/ogreceguirenderer/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/ogreceguirenderer/CMakeLists.txt	(revision 5929)
@@ -18,17 +18,15 @@
  #
 
-SET(OCR_FILES
+SET_SOURCE_FILES(OCR_FILES
   OgreCEGUIRenderer.h
   OgreCEGUIResourceProvider.h
   OgreCEGUITexture.h
 
+COMPILATION_BEGIN OgreCEGUIRendererCompilation.cpp
   OgreCEGUIRenderer.cpp
   OgreCEGUIResourceProvider.cpp
   OgreCEGUITexture.cpp
+COMPILATION_END
 )
-
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
 
 ORXONOX_ADD_LIBRARY(ogreceguirenderer_orxonox
Index: /code/trunk/src/external/ois/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/ois/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/ois/CMakeLists.txt	(revision 5929)
@@ -34,4 +34,5 @@
   OISPrereqs.h
 
+COMPILATION_BEGIN OISCompilation.cpp
   OISEffect.cpp
   OISException.cpp
@@ -41,4 +42,5 @@
   OISKeyboard.cpp
   OISObject.cpp
+COMPILATION_END
 )
 IF(WIN32)
@@ -49,8 +51,4 @@
   ADD_SUBDIRECTORY(linux)
 ENDIF()
-
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
 
 INCLUDE_DIRECTORIES(.)
Index: /code/trunk/src/external/ois/linux/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/ois/linux/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/ois/linux/CMakeLists.txt	(revision 5929)
@@ -8,4 +8,5 @@
   LinuxPrereqs.h
 
+COMPILATION_BEGIN OISLinuxCompilation.cpp
   EventHelpers.cpp
   LinuxForceFeedback.cpp
@@ -14,3 +15,4 @@
   LinuxKeyboard.cpp
   LinuxMouse.cpp
+COMPILATION_END
 )
Index: /code/trunk/src/external/ois/mac/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/ois/mac/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/ois/mac/CMakeLists.txt	(revision 5929)
@@ -7,4 +7,5 @@
   MacPrereqs.h
 
+COMPILATION_BEGIN OISMacCompilation.cpp
   MacHelpers.cpp
   MacHIDManager.cpp
@@ -12,3 +13,4 @@
   MacKeyboard.cpp
   MacMouse.cpp
+COMPILATION_END
 )
Index: /code/trunk/src/external/ois/win32/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/ois/win32/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/ois/win32/CMakeLists.txt	(revision 5929)
@@ -7,4 +7,5 @@
   Win32Prereqs.h
 
+COMPILATION_BEGIN OISWin32Compilation.cpp
   Win32ForceFeedback.cpp
   Win32InputManager.cpp
@@ -12,3 +13,4 @@
   Win32KeyBoard.cpp
   Win32Mouse.cpp
+COMPILATION_END
 )
Index: /code/trunk/src/external/ois/win32/Win32ForceFeedback.cpp
===================================================================
--- /code/trunk/src/external/ois/win32/Win32ForceFeedback.cpp	(revision 5928)
+++ /code/trunk/src/external/ois/win32/Win32ForceFeedback.cpp	(revision 5929)
@@ -26,5 +26,5 @@
 
 // 0 = No trace; 1 = Important traces; 2 = Debug traces
-#define OIS_WIN32_JOYFF_DEBUG 1
+#define OIS_WIN32_JOYFF_DEBUG 0
 
 #if (defined (_DEBUG) || defined(OIS_WIN32_JOYFF_DEBUG))
Index: /code/trunk/src/external/tinyxml/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/tinyxml/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/tinyxml/CMakeLists.txt	(revision 5929)
@@ -18,5 +18,5 @@
  #
 
-SET(TINYXML++_FILES
+SET_SOURCE_FILES(TINYXML++_FILES
   ticpp.h
   ticpprc.h
@@ -24,4 +24,5 @@
   tinyxml.h
 
+COMPILATION_BEGIN TicppCompilation.cpp
   ticpp.cpp
   tinystr.cpp
@@ -29,9 +30,6 @@
   tinyxmlerror.cpp
   tinyxmlparser.cpp
+COMPILATION_END
 )
-
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
 
 ORXONOX_ADD_LIBRARY(tinyxml++_orxonox
Index: /code/trunk/src/external/tolua/CMakeLists.txt
===================================================================
--- /code/trunk/src/external/tolua/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/external/tolua/CMakeLists.txt	(revision 5929)
@@ -20,8 +20,8 @@
 ################### Tolua++ library ###################
 
-SET(TOLUA++_FILES
+SET_SOURCE_FILES(TOLUA++_FILES
   tolua_event.h
   tolua++.h
-
+COMPILATION_BEGIN ToluaCompilation.c
   tolua_event.c
   tolua_is.c
@@ -29,10 +29,6 @@
   tolua_push.c
   tolua_to.c
+COMPILATION_END
 )
-GENERATE_SOURCE_GROUPS(${TOLUA++_FILES})
-
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
 
 ORXONOX_ADD_LIBRARY(tolua++_orxonox
Index: /code/trunk/src/libraries/core/ArgumentCompletionFunctions.cc
===================================================================
--- /code/trunk/src/libraries/core/ArgumentCompletionFunctions.cc	(revision 5928)
+++ /code/trunk/src/libraries/core/ArgumentCompletionFunctions.cc	(revision 5929)
@@ -100,5 +100,5 @@
             ArgumentCompletionList classlist;
 
-            for (std::map<std::string, Identifier*>::const_iterator it = Identifier::getIdentifierMapBegin(); it != Identifier::getIdentifierMapEnd(); ++it)
+            for (std::map<std::string, Identifier*>::const_iterator it = Identifier::getStringIdentifierMapBegin(); it != Identifier::getStringIdentifierMapEnd(); ++it)
                 if ((*it).second->hasConfigValues())
                     classlist.push_back(ArgumentCompletionListElement((*it).second->getName(), getLowercase((*it).first)));
@@ -110,7 +110,7 @@
         {
             ArgumentCompletionList configvalues;
-            std::map<std::string, Identifier*>::const_iterator identifier = Identifier::getIdentifierMap().find(classname);
+            std::map<std::string, Identifier*>::const_iterator identifier = Identifier::getStringIdentifierMap().find(classname);
 
-            if (identifier != Identifier::getIdentifierMapEnd() && (*identifier).second->hasConfigValues())
+            if (identifier != Identifier::getStringIdentifierMapEnd() && (*identifier).second->hasConfigValues())
             {
                 for (std::map<std::string, ConfigValueContainer*>::const_iterator it = (*identifier).second->getConfigValueMapBegin(); it != (*identifier).second->getConfigValueMapEnd(); ++it)
@@ -124,6 +124,6 @@
         {
             ArgumentCompletionList oldvalue;
-            std::map<std::string, Identifier*>::const_iterator identifier = Identifier::getLowercaseIdentifierMap().find(getLowercase(classname));
-            if (identifier != Identifier::getLowercaseIdentifierMapEnd())
+            std::map<std::string, Identifier*>::const_iterator identifier = Identifier::getLowercaseStringIdentifierMap().find(getLowercase(classname));
+            if (identifier != Identifier::getLowercaseStringIdentifierMapEnd())
             {
                 std::map<std::string, ConfigValueContainer*>::const_iterator variable = (*identifier).second->getLowercaseConfigValueMap().find(getLowercase(varname));
